<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;
use Modules\Core\Enums\StatusEnum;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('employee_holiday_groups', function (Blueprint $table) {
            $table->id();

            $table->foreignId('employee_id')
                ->constrained('employees')
                ->cascadeOnDelete();

            $table->foreignId('holiday_group_id')
                ->constrained('holiday_groups')
                ->cascadeOnDelete();

            // একই সময়ে মাল্টিপল একটিভ রেকর্ড ব্লক করার জন্য ইনডেক্সিং
            $table->enum('status', StatusEnum::casesAsArray())->default(StatusEnum::Active->value);

            $table->date('assigned_from'); // নাল রাখা যাবে না, অ্যাসাইনমেন্ট শুরুর ডেট অবশ্যই লাগবে
            $table->date('assigned_to')->nullable(); // কারেন্ট একটিভ গ্রুপের জন্য নাল থাকবে

            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('employee_holiday_groups');
    }
};
